<?php

/*

 $Id: flo.php,v 1.9 2003/06/13 16:28:54 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/modules/flo.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Flo Module Document
	This document handles an actions for the flo module.
*/

/* Start House Keeping */

	require "../../modules/config.php";

	// do anything that needs to be done here
	check_session();

	// setup the user environment
	setup_user_environment($action, $zone_id);

/* End House Keeping */

$flo = new Flo(0);
if ($host_id) { $host = new Host($host_id); }
?>

<? show_template('header'); ?>
<? if ($host_id) { ?>
<p><font class="header1">Flow Information for <?= $host->hostname; ?></font></p> 
<? } elseif (!$host_id && $ip_int) { ?>
<p><font class="header1">Flow Information for <? $ip = new Ip(0); echo $ip->int2ip($ip_int); ?></font></p>
<? } else { ?>
<p><font class="header1">Host Flow Information</font></p>
<? } ?>

<?
//display if block
//default view for a single host. 
if ($action == "view_single_host") {
	//first grab the bandwidth information
	if ($host) {
		$ip_int = $host->ip->ip_int;
	}
	
	$flo = new Flo(0);

	$flows = $flo->get_host_flows($ip_int);
	$flo->show_single_host_flow($flows);

} //view_single_host	 
elseif ( $action == 'view_single_host_graph' ) {
	if ( $host ) {
		$ip_addr       = $host->ip->ip_addr;
		$ip_int   = $host->ip->ip_int;
		$hostname = $host->name . "." . $host->domain->name;
		$title = "Cumulative Bandwidth Usage: ";
		$subtitle = "$hostname ($ip_addr)";
	}
	else {
		$ip_obj = new Ip($ip_int); 
		$ip_addr = $ip_obj->int2ip($ip_int);
		$hostname = "Host Not Registered in Maintain";
		$title = "Cumulative Bandwidth Usage: ";
		$subtitle= "Unknown -- " . $ip_addr;
	} 
	$flows = $flo->get_host_flows($ip_int);
	$flo->graph($title, $subtitle, $ip_addr, $flows);
	$flo->show_single_host_flo_graph($title, $ip_addr);
}
//show the top X hosts for the selected day.
elseif ($action == "show_top") {
	//if they've picked a date then show the date picker last
	if ($date) {
		$in_flows = $flo->get_top_in_flows($date,$count);
		$out_flows = $flo->get_top_out_flows($date,$count);
		
		$flo->show_flows($in_flows,$out_flows,0,$date);

	} //check for date

	require ($conf['prefix'] . "/templates/show_flo_select.inc");
	
} //show_top	

//show the top X hosts in specified zone
elseif ($action == "show_top_zone") {
	//if they've picked a date then show the date picker last
	if ($date && $zone_id) {
		$in_flows = $flo->get_zone_flows($zone_id,$date,"in_kb",$count);
		$out_flows = $flo->get_zone_flows($zone_id,$date,"out_kb",$count);
			
		$flo->show_flows($in_flows,$out_flows,0,$date);
	}

	require ($conf['prefix'] . "/templates/show_flo_select.inc");

} //show_top_zone

elseif ($action == "show_top_range") {
        //if they've picked a date then show the date picker last
        if ($date && $range_id) {
                $in_flows = $flo->get_range_flows($range_id,$date,"in_kb",$count);
                $out_flows = $flo->get_range_flows($range_id,$date,"out_kb",$count);

                $flo->show_flows($in_flows,$out_flows,0,$date);
        }

        require ($conf['prefix'] . "/templates/show_flo_select.inc");

} //show_top_zone


?>

<? show_template('footer'); ?>


