<?php
/*

 $Id: workgroup.php,v 1.18 2003/08/05 23:00:03 vollmerk Exp $
 $Source: /data/cvsroot/maint/docs/workgroup.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header Workgroup Document
	Create/edit/delete Workgroups.

*/

/* Start House Keeping */

	require("../modules/config.php");

	// make sure they are supposed to be here
	check_session();

	setup_user_environment($action, $zone_id);
/* End House Keeping */

// Only admins and zone admins should be here
if ( ! $user->is_admin && ! $user->is_zone_admin) {
        header("Location: " . $conf['web_path'] . "/index.php");
	exit();
}

// process any submits that may come our way
$title = "Workgroup Information";

// need this object for doing the IP math
$ip = new IP (0);

// now do things based on the form data
if ( ( $action == 'Create' || $action == 'Update' ) && $user->is_admin) {

	// uh-oh, at least type something
	if ( !$name || !$subnet_id ) {
		$conf['error']->add_error('workgroup_top', "Please enter values for the form.");
	}

	if ( $conf['error']->error_state ) {
		// there was an error so set the appropriate action
		if ( $action == 'Create' ) {
			$action = 'show_create';
		}
		else {
			$action = 'edit';
			$workgroup = new Workgroup($workgroup_id);
		}

		$workgroup->name              = $name;
		$workgroup->subnet->ip_addr   = $subnet_mask;
		$workgroup->vlan->name        = $netmask;
	}
	else {
		// create/update the stinkin' workgroup 
		if ( $action == 'Create' && $user->is_admin) {
			$sql = "INSERT INTO workgroup (name,subnet,vlan,zone) VALUES ('$name',$subnet_id,$vlan_id,$zone_id)";
			$db_result = mysql_query($sql, $conf['dbh']);	
			$workgroup_id = mysql_insert_id($conf['dbh']);
		} // if create and admin

		else {
			if (!$use_zone) { $zone_id = 0; }
			$sql = "UPDATE workgroup SET name='$name',subnet=$subnet_id,vlan=$vlan_id, zone='$zone_id', WHERE id=$workgroup_id";
			$db_result = mysql_query($sql, $conf['dbh']);	
		}

		$action = 'edit';
		$workgroup = new Workgroup($workgroup_id);
	}
}
// this we're really deleting this zone
elseif ( $action == 'delete' && $really ) {

	if ($user->is_admin || $user->has_access($workgroup->zone) >= 50 ) {
		$sql = "DELETE FROM workgroup WHERE id=$workgroup_id";
		$db_result = mysql_query($sql, $conf['dbh']);
	}
	else {
		$conf['ui']->show_access_denied();
	}

	$action = 'show_workgroups';
}

elseif ( $action == 'edit' ) {
		$workgroup = new Workgroup($workgroup_id);
}

show_template('header');

?>
<font class="header1"><?= $title ?></font>

<?php 

/**************************
	SHOW IF BLOCK
**************************/


	if ($zone_id) {
		$sql = "SELECT id FROM workgroup WHERE zone='$zone_id'";
	}
	elseif ($user->is_admin) {
		$sql = "SELECT id FROM workgroup";
	}

	if (!$user->view) {
                $user->view = new View($sql);
        }

	if ($sort_type) {
		$user->view->initialize($sort_type,$sort_offset);
        }
        else {
		$user->view->initialize('name', $sort_offset);
        }


	if ( $action == 'edit' || $action == 'show_create' ) {
		// show the range edit form
		$conf['ui']->show_workgroup($action, $workgroup);
	}

	elseif ( $action == 'show_workgroups' ) {
		$workgroups = $conf['ui']->get_workgroups();
		$conf['ui']->show_workgroups('', $workgroups);
	}
	
	elseif ( $action == 'show_workgroup_ranges' ) {
		$workgroup = new Workgroup($workgroup_id);
		$ranges    = $workgroup->get_ranges();

		$conf[ui]->show_workgroup_ranges($action, $workgroup, $ranges);
	}

	elseif ( $action == 'delete' || $action == 'Delete' ) {
		// show the confirm delete
		$workgroup = new Workgroup($workgroup_id);

		$name      = $workgroup->name;
		$subnet    = new Subnet($workgroup->subnet->id);
		$vlan      = new VLAN($workgroup->vlan->id);
		$conf['ui']->show_confirm($conf['web_path'] . "/workgroup.php?action=delete&really=1&workgroup_id=$workgroup_id","Are you sure you want to delete this workgroup? <b>($name using subnet '$subnet->name' and VLAN $vlan->name)</b>");
	}


show_template('footer'); 

?>
