<?php

/*

 $Id: mx.php,v 1.19 2003/07/31 16:29:56 vollmerk Exp $
 $Source: /data/cvsroot/maint/modules/class/mx.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header MX Record Class
	The mx record object ... functions for manipulating & changing

*/

class Mx {
	var $id;
	var $name;
	var $domain; // this is a domain_id
	var $server; // the server that we are pointing this MX to
	var $priority;
	var $hostname;
	var $zone; // zone id
	var $object_history;

	// we can populate this stuff from the database -- no sense in
	//   passing it in.
	function Mx ( $mx_id = 0 ) {
		global $conf;

		$this->id = $mx_id;

		$info = $this->get_info();

		if ($info ) {
			$this->name     = $info->name;
			$this->domain   = new Domain($info->domain);
			$this->server   = $info->server;
			$this->priority = $info->priority;
			$this->hostname = $this->name . "." . $this->domain->name;
			$this->zone     = new Zone($info->zone);
			$this->last_update = $info->last_update;
			$this->who_update = $info->who_update;
			$this->comment = $info->comment;
		}

		$this->object_history = new ObjectHistory('mx', $this->id);

	} // MX

	function get_info () {
		global $conf;

		$sql = "SELECT * FROM zone_mx WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);
		
		return mysql_fetch_object($db_result);

	} // get_info

	function update_name ($newname)
	{
		$this->update_item('name', $newname);
		$this->name = $newname;
	}
	function update_domain ($newdomain)
	{
		$this->update_item('domain', $newdomain);
		$this->domain = new Domain($newdomain);
	}	
	function update_server ($newserver)
	{
		$this->update_item('server', $newserver);
		$this->server = $newserver;
	}
	function update_priority($newpriority)
	{
		$this->update_item('priority', $newpriority);
		$this->priority = $newpriority;
	}
	// end of the update functions

	function update_item($type, $new_item)
	{

		global $conf;

		$sql = "UPDATE zone_mx SET $type='$new_item' WHERE id='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} // update_item

	//move the mx record to a different zone
	function move_mx($mx_id,$zone_id) {
		global $conf;
		
		$sql = "UPDATE zone_mx SET zone='$zone_id' WHERE id='$mx_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} //move_mx

	//check for duplicate and valid names
	function check_name($name, $domain, $priority) {
		global $user, $conf;
	
		//first let's make sure there isn't already a mx record with the same name in the db already
		//  but it can have a different priority
		$sql = "SELECT * FROM zone_mx WHERE name LIKE '$name' AND domain='$domain->id' AND priority=$priority";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (mysql_fetch_object($db_results)) {
				$conf['error']->add_error('name', "$name.$domain->name is already in use by an MX Record.");
				return false;
		}

		if (!preg_match("/^[\w-]+$/", $name)) {
			$conf['error']->add_error('name', "$name.$domain->name is an invalid MX record");
			return false;
		}
 
                $sql = "SELECT * FROM zone_cname WHERE name LIKE '$name' AND domain='$domain->id'";
                $db_results = mysql_query($sql,$conf['dbh']);
                $count = mysql_num_rows($db_results);

                if ($count) {
                	$conf['error']->add_error('name', "$name.$domain->name is already in use by a CNAME.");
		}

	} // check_name

	//check for valid servername
	function check_server($server)
	{
		global $user, $conf;	
	
		//first lets make sure they aren't pointing a MX at a CNAME
		$data = split_hostname($server);
		$sql = "SELECT * FROM zone_cname,domain WHERE zone_cname.domain=domain.id AND zone_cname.name='$data->name' AND domain.name='$data->domain'";
		$db_results = mysql_query($sql, $conf['dbh']);
		if (mysql_fetch_row($db_results)) {
			$conf['error']->add_error('server', "$server is already a CNAME.<br />\n You can not have a MX record point to a CNAME");
			}

		//now let's check and make sure that there are valid chr's in the server
		if (! preg_match("/^\w+\.\w+/", $server)) {
			$conf['error']->add_error('server', "$server is an invalid servername");
			}

	} // check_server

	//check that we aren't setting this host to the same priority
	function check_priority($name, $domain, $priority)
	{
		global $user, $conf;	
	
		//first lets make sure they aren't pointing a MX at a CNAME
		$sql = "SELECT * FROM zone_mx WHERE name='$name' AND domain='$domain->id' AND priority='$priority' AND id!='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		if (mysql_fetch_row($db_results)) {
			$conf['error']->add_error('server', "You cannot have two MX records with the same priority.");
		}

	} // check_priority

	// fry the item! (taken from current cname)
	function delete_item($id) {
		global $conf;
	
		$sql = "DELETE FROM zone_mx WHERE id='$id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} // delete_item

	// insert the values into the table in a new row
	function new_item($name,$server,$domain,$priority,$zone) {

		global $user, $conf;

		$sql = "INSERT INTO zone_mx SET id='', server='$server', name='$name', domain='$domain', priority='$priority', zone='$zone'";
		$db_results = mysql_query($sql, $conf['dbh']);
		$mx_id = mysql_insert_id($conf['dbh']);

		return $mx_id;

	} // new_item

}

?>
